// RfidEventDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "RfidEvent.h"
#include "RfidEventDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRfidEventDlg dialog box

CRfidEventDlg::CRfidEventDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRfidEventDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRfidEventDlg)
		// Class Wizard will add member initializations here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_sockUdp = INVALID_SOCKET;
    m_sockTcp = INVALID_SOCKET;
    }

CRfidEventDlg::~CRfidEventDlg()
    {
    if( m_sockUdp != INVALID_SOCKET )
        closesocket( m_sockUdp );
    if( m_sockTcp != INVALID_SOCKET )
        closesocket( m_sockTcp );
    }


void CRfidEventDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRfidEventDlg)
	DDX_Control(pDX, IDC_PACKETS, m_lbPackets);
	DDX_Control(pDX, IDC_PORT, m_cbPort);
	DDX_Control(pDX, IDC_ADDRESS, m_cbAddress);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRfidEventDlg, CDialog)
	//{{AFX_MSG_MAP(CRfidEventDlg)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_LBN_SELCHANGE(IDC_PACKETS, OnSelchangePackets)
	ON_BN_CLICKED(IDC_CLEARBUF, OnClearbuf)
	ON_BN_CLICKED(IDC_READBUF, OnReadbuf)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRfidEventDlg message handlers

BOOL CRfidEventDlg::OnInitDialog()
    {
    struct sockaddr_in sa;
    int nDummy = TRUE;

	CDialog::OnInitDialog();

    // Request an icon for the dialog's title bar.
	SetIcon( m_hIcon, TRUE );
	
    // Some more initilizations
    m_cbPort.AddString( "2683" );
    ConditionalFields();

    // Start an inventory broadcast that will find all W&T devices on the network.
    m_sockUdp = socket( AF_INET, SOCK_DGRAM, 0 );
    WSAAsyncSelect( m_sockUdp, m_hWnd, WM_APP, FD_READ );
    sa.sin_family = AF_INET;
    sa.sin_port = htons( 8513 );
    sa.sin_addr.s_addr = INADDR_BROADCAST;
    setsockopt( m_sockUdp, SOL_SOCKET, SO_BROADCAST, (char *)&nDummy, sizeof( nDummy ) );
    nDummy = sendto( m_sockUdp, "?", 1, 0, (struct sockaddr *)&sa, sizeof( sa ) ); 
	
	return TRUE;  // return TRUE, unless you set the focus to a control
    }

LRESULT CRfidEventDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
    {
	if( message == WM_APP )
        {
        if( WSAGETSELECTEVENT( lParam ) == FD_READ && wParam == m_sockUdp )
            {
            // Found a W&T device, add it to the address combo box
            char caBuf[ 80 ];
            struct sockaddr_in sa;
            int nLen, nMax;

            nLen = sizeof( sa );
            nMax = sizeof( caBuf );
            nLen = recvfrom( m_sockUdp, caBuf, nMax, 0, (SOCKADDR *)&sa, &nLen );
            if( nLen >= 0 )
                m_cbAddress.AddString( inet_ntoa( sa.sin_addr ) );
            }
        if( WSAGETSELECTEVENT( lParam ) == FD_READ && wParam == m_sockTcp )
            {
            // Incoming data from the RFID server. Try to receive it as a packet.
            OnReceive();
            }
        }
	
	return CDialog::WindowProc(message, wParam, lParam);
    }

void CRfidEventDlg::OnConnect() 
    {
    struct sockaddr_in sa;
    WORD wPort;
    FD_SET fdsWrite, fdsError;
    timeval tv = { 0, 0 };
    CString str;
    CWaitCursor wc; // display an hourglass

    // Read target device information
    wPort = GetDlgItemInt( IDC_PORT );
    GetDlgItemText( IDC_ADDRESS, str );

    sa.sin_family = AF_INET;
    sa.sin_port = htons( wPort );
    sa.sin_addr.s_addr = inet_addr( str );
    m_sockTcp = socket( PF_INET, SOCK_STREAM, 0 );
    if( m_sockTcp == INVALID_SOCKET )
        return;
    
    // Request Winsock notifications for this socket (which implies
    // non-blocking mode btw., but we'd need that anyway).
    WSAAsyncSelect( m_sockTcp, m_hWnd, WM_APP, FD_READ );

    // Open the TCP connection (non-blocking connect)
    connect( m_sockTcp, (SOCKADDR*)&sa, sizeof( sa ) );
    FD_ZERO( &fdsWrite );  
    FD_SET( m_sockTcp, &fdsWrite );
    FD_ZERO( &fdsError );  
    FD_SET( m_sockTcp, &fdsError );
    // Allow up to four seconds to connect
    tv.tv_sec = 4;
    if( select( m_sockTcp+1, NULL, &fdsWrite, &fdsError, &tv ) <= 0 )
        {
        str.LoadString( IDS_E_TIMEOUT );
        goto socket_fail;
        }
    if( FD_ISSET( m_sockTcp, &fdsError ) )
        {
        str.Format( IDS_E_REFUSED, wPort );
        goto socket_fail;
        }

    m_nData = 0;
    m_nDrop = 0;
    m_fStalled = FALSE;
    m_fComplete = FALSE;
    SetDlgItemText( IDC_STATUS, "" );
    ConditionalFields();
    m_lbPackets.ResetContent();

    // Send password, if there is one, including the trailing null
    GetDlgItemText( IDC_PASSWD, str );
    if( !str.IsEmpty() )
        send( m_sockTcp, str, str.GetLength()+1, 0 );
    // Do a dummy transaction to find out if we were successful.
    Talk( CMD_GET_IO, NULL, 0 );
    return;

socket_fail:
    SetDlgItemText( IDC_STATUS, str );
    MessageBeep( MB_ICONERROR );
    closesocket( m_sockTcp );
    m_sockTcp = INVALID_SOCKET;
    }

void CRfidEventDlg::OnDisconnect() 
    {
    closesocket( m_sockTcp );
    m_sockTcp = INVALID_SOCKET;
    SetDlgItemText( IDC_STATUS, "" );
    ConditionalFields();
    }


void CRfidEventDlg::OnSelchangePackets() 
    {
#define BYTELEN 3   // characters per byte in the packet string
    CString strPkt, str, str2;
    BYTE baBuf[ 80 ];
    WT_BINHDR *pbhdr;
    T_FILTERMATCH *pfm;
    int i, n;

    // Read the selected row from the list and analyze it.
    i = m_lbPackets.GetCurSel();
    if( i < 0 )
        return;
    m_lbPackets.GetText( i, strPkt );
    // Remove everything but the hex digits
    strPkt.TrimLeft( "<-> " );
    n = strPkt.GetLength() / BYTELEN;
    if( n > sizeof( baBuf ) )
        n = sizeof( baBuf );
    for( i = 0; i < n; i++ )
        baBuf[ i ] = (BYTE)strtol( strPkt.Mid( i*BYTELEN, BYTELEN ), NULL, 16 );
    // Packet header
    pbhdr = (WT_BINHDR *)baBuf;
    SetDlgItemText( IDC_ZERO, strPkt.Left( 4*BYTELEN ) );
    SetDlgItemText( IDC_TYPE_RAW, strPkt.Mid( 4*BYTELEN, 2*BYTELEN ) );
    SetDlgItemText( IDC_LEN_RAW, strPkt.Mid( 6*BYTELEN, 2*BYTELEN ) );
    str2.Format( "0x%04x", pbhdr->struct_type );
    switch( pbhdr->struct_type )
        {
        case CMD_FILTERMATCH:
            str2 += " (filter match event)";
            break;
        case CMD_BUFFERED_MATCH:
            str2 += " (read from event buffer)";
            break;
        case CMD_CLEAR_BUFFER:
            str2 += " (clear event buffer)";
            break;
        case CMD_READ_FLASH:
            str2 += " (read from flash)";
            break;
        case CMD_WRITE_FLASH:
            str2 += " (write to flash)";
            break;
        case CMD_GET_IO:
            str2 += " (get digital I/O)";
            break;
        case CMD_SET_OUTPUT:
            str2 += " (set digital output)";
            break;
        case ERR_SYNTAX:
            str2 += " (syntax error)";
            break;
        case ERR_SEMANTIC:
            str2 += " (functional error)";
            break;
        }
    SetDlgItemText( IDC_TYPE_TRSL, str2 );
    str2.Format( "%d (8 + %d)", pbhdr->struct_length, pbhdr->struct_length-8 );
    SetDlgItemText( IDC_LEN_TRSL, str2 );
    // More details, if it's a tag event
    if( (pbhdr->struct_type == CMD_FILTERMATCH || pbhdr->struct_type == CMD_BUFFERED_MATCH)
      && pbhdr->struct_length >= 25 )
        {
        char *pcaDay[] = { "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "???" };

        pfm = (T_FILTERMATCH *)(baBuf + sizeof( WT_BINHDR ));
        SetDlgItemText( IDC_ACTION_RAW, strPkt.Mid( 8*BYTELEN, BYTELEN ) );
        SetDlgItemText( IDC_TAGID_RAW, strPkt.Mid( 9*BYTELEN, 8*BYTELEN ) );
        SetDlgItemText( IDC_TSTAMP_RAW, strPkt.Mid( 17*BYTELEN, 7*BYTELEN ) );
        SetDlgItemText( IDC_FSET_RAW, strPkt.Mid( 24*BYTELEN, BYTELEN ) );
        SetDlgItemText( IDC_ACTION_TRSL, pfm->bAction ? "coming" : "going" );
        str.Empty();
        for( i = 0; i < 8; i++ )
            {
            if( i > 0 )
                str += "-";
            str2.Format( "%02X", pfm->baTagID[ 7-i ] );
            str += str2;
            }
        SetDlgItemText( IDC_TAGID_TRSL, str );
        str.Format( "%d-%02d-%02d %s %02d:%02d:%02d", 
            pfm->ts.bYear+2000, pfm->ts.bMonth, pfm->ts.bDay, 
            pcaDay[ pfm->ts.bWeekday & 0x07 ],
            pfm->ts.bHour, pfm->ts.bMinute, pfm->ts.bSecond );
        SetDlgItemText( IDC_TSTAMP_TRSL, str );
        SetDlgItemInt( IDC_FSET_TRSL, pfm->bFilterset );
        }
    else
        {
        SetDlgItemText( IDC_ACTION_RAW, "" );
        SetDlgItemText( IDC_TAGID_RAW, "" );
        SetDlgItemText( IDC_TSTAMP_RAW, "" );
        SetDlgItemText( IDC_FSET_RAW, "" );
        SetDlgItemText( IDC_ACTION_TRSL, "" );
        SetDlgItemText( IDC_TAGID_TRSL, "" );
        SetDlgItemText( IDC_TSTAMP_TRSL, "" );
        SetDlgItemText( IDC_FSET_TRSL, "" );
        }
    }

void CRfidEventDlg::OnReadbuf() 
    {
    Talk( CMD_BUFFERED_MATCH, NULL, 0 );
    }

void CRfidEventDlg::OnClearbuf() 
    {
    Talk( CMD_CLEAR_BUFFER, NULL, 0 );
    }

/////////////////////////////////////////////////////////////////////////////
// CRfidEventDlg private subroutines

void CRfidEventDlg::SafeEnableItem( int nCtrl, BOOL fEnable )
    {
    CWnd *pwnd, *pfoc;

    // Disabling a control that has the focus is ugly. So move the focus,
    // if required. Note that for comboboxes, the focus is usually on
    // a child window (edit control), not the control itself.
    pwnd = GetDlgItem( nCtrl );
    pfoc = GetFocus();
    if( !fEnable )
        if( pwnd == pfoc || (pfoc && pwnd == pfoc->GetParent() ) )
            SendMessage( WM_NEXTDLGCTL, 1, 0 );
    pwnd->EnableWindow( fEnable );
    }

void CRfidEventDlg::ConditionalFields()
    {
    // Check for an established connection and enable/disable some controls 
    BOOL fOnline = (m_sockTcp != INVALID_SOCKET);

    SafeEnableItem( IDC_ADDRESS, !fOnline );
    SafeEnableItem( IDC_PORT,    !fOnline );
    SafeEnableItem( IDC_PASSWD,  !fOnline );
    SafeEnableItem( IDC_CONNECT, !fOnline );
    SafeEnableItem( IDC_DISCONNECT, fOnline );
    SafeEnableItem( IDC_READBUF,  fOnline );
    SafeEnableItem( IDC_CLEARBUF, fOnline );
    }


// Send a protocol packet

BOOL CRfidEventDlg::Talk( int nCmd, const char *pcData, int nDataLen )
    {
    WT_BINHDR bhdr;
    CString str, str2;
    int i, j;
    BYTE *pb;

    // Create and send the header
    bhdr.zero = 0;
    bhdr.struct_type = nCmd;
    bhdr.struct_length = nDataLen + sizeof( bhdr );
    if( send( m_sockTcp, (char *)&bhdr, sizeof( bhdr ), 0 ) < 0 )
        goto socket_fail;

    // Send the related data, if there are any
    if( nDataLen > 0 )
        if( send( m_sockTcp, pcData, nDataLen, 0 ) < 0 )
            goto socket_fail;

    str = "->  ";
    for( i = 0; i < bhdr.struct_length; i++ )
        {
        j = i - sizeof( bhdr ); 
        if( j < 0 )
            pb = i + (BYTE *)&bhdr;
        else
            pb = j + (BYTE *)pcData;
        str2.Format( "%02X ", *pb );
        str += str2;
        }
    m_lbPackets.AddString( str );
    return TRUE;

socket_fail:
    str.Format( IDS_E_CONNFAILED, WSAGetLastError() );
    OnDisconnect();
    SetDlgItemText( IDC_STATUS, str );
    return FALSE;
    }




// OnReceive() is called, whenever new TCP data have arrived.
// Note that we cannot rely on data arriving one protocol packet at a time.
// The packet data may arrive in several pieces, and several packets may 
// arrive at once.

void CRfidEventDlg::OnReceive()
    {
    int i, j, nResult, nDemand, nFill;
    char caLocalBuf[ 200 ];
    BYTE *pb;
    CString str, str2;

    // Unfortunately, OnReceive() may be entered recursively. 
    // In that case, we MUST ignore the most recent FD_READ, and we MUST set 
    // a flag for the original invocation of OnReceive() to restart the 
    // FD_READ notifications later.
    if( m_fComplete )
        {
        TRACE( "recursive FD_READ!\n" );
        m_fStalled = TRUE;
        return;
        }

    while( m_nDrop > 0 )
        {
        // Throw away any remains of a previous packet
        nDemand = sizeof( caLocalBuf );
        if( nDemand > m_nDrop )
            nDemand = m_nDrop;
        TRACE( "dropping %d bytes\n", nDemand );
        nResult = recv( m_sockTcp, caLocalBuf, nDemand, 0 );
        if( nResult == 0 )
            goto closed;
        else if( nResult > 0 )
            m_nDrop -= nResult;
        else
            return;
        }

    if( m_nData < sizeof( m_bhdr ) )
        {
        // Receive header data
        nResult = recv( m_sockTcp, ((char *)&m_bhdr) + m_nData, sizeof( m_bhdr ) - m_nData, 0 );
        if( nResult == 0 )
            goto closed;
        else if( nResult > 0 )
            m_nData += nResult;
        }
    if( m_nData < sizeof( m_bhdr ) )
        return; // header not yet complete

    if( strcmp( (char *)&m_bhdr, "PASSWD?" ) == 0 )
        {
        str = "PASSWD?";
        goto fail;
        }

    // Header is complete, and now we know the amount of data that follow.
    nDemand = m_bhdr.struct_length - sizeof( m_bhdr );
    if( nDemand > sizeof( m_baBuf ) )
        nDemand = sizeof( m_baBuf );
    nFill = m_nData - sizeof( m_bhdr );
    nDemand -= nFill;
    if( nDemand > 0 )
        {
        nResult = recv( m_sockTcp, (char *)(m_baBuf + nFill), nDemand, 0 );
        TRACE( "recv(): got %d out of %d bytes\n", nResult, nDemand );
        if( nResult == 0 )
            goto closed;
        else if( nResult > 0 )
            m_nData += nResult;
        else
            return;
        }
    else
        nResult = nDemand;

    if( nResult == nDemand )
        {
        // Packet is complete (or at least we have received as much of it as
        // our buffer will hold).
        m_fComplete = TRUE;

        // Check for error responses
        switch( m_bhdr.struct_type )
            {
            case ERR_SYNTAX:
                // Oops. Apparently we screwed up with the network protocol. 
                // It's better to abandon the connection.
                str.Format( IDS_E_SYNTAX, *(WORD *)m_baBuf );
                goto fail;
            case ERR_SEMANTIC:
                str.Format( IDS_E_SEMANTIC, *(WORD *)m_baBuf );
                SetDlgItemText( IDC_STATUS, str );
                goto quit;
            }

        // Append the packet data to the list box.
        str = "<-  ";
        for( i = 0; i < m_bhdr.struct_length; i++ )
            {
            j = i - sizeof( m_bhdr ); 
            if( j < 0 )
                pb = i + (BYTE *)&m_bhdr;
            else
                pb = j + m_baBuf;
            str2.Format( "%02X ", *pb );
            str += str2;
            }
        m_lbPackets.AddString( str );

        // Throw away the packet and any excess data
        m_nDrop = m_bhdr.struct_length - m_nData;
        m_nData = 0;
        m_fComplete = FALSE;
    quit:
        if( m_fStalled )
            {
            // Apparently we had to drop an FD_READ notification.
            // Make sure that we get a new one.
            TRACE( "restart FD_READ chain...\n" );
            m_fStalled = FALSE;
            recv( m_sockTcp, caLocalBuf, 0, 0 );
            }
        return;
        }

closed:
    str.LoadString( IDS_E_CONNCLOSED );
fail:
    OnDisconnect();
    SetDlgItemText( IDC_STATUS, str );
    }
