// RfidIODlg.cpp : Implementation
//

#include "stdafx.h"
#include "RfidFlash.h"
#include "RfidFlashDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRfidFlashDlg Dialogfeld

CRfidFlashDlg::CRfidFlashDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRfidFlashDlg::IDD, pParent)
    {
	//{{AFX_DATA_INIT(CRfidIODlg)
		// Class Wizard will add member initializations here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon( IDR_MAINFRAME );
    m_sockUdp = INVALID_SOCKET;
    m_sockTcp = INVALID_SOCKET;
    }

CRfidFlashDlg::~CRfidFlashDlg()
    {
    if( m_sockUdp != INVALID_SOCKET )
        closesocket( m_sockUdp );
    if( m_sockTcp != INVALID_SOCKET )
        closesocket( m_sockTcp );
    }

void CRfidFlashDlg::DoDataExchange(CDataExchange* pDX)
    {
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CRfidFlashDlg)
	DDX_Control(pDX, IDC_TAGLIST, m_lbTaglist);
	DDX_Control(pDX, IDC_ADDRESS, m_cbAddress);
	DDX_Control(pDX, IDC_PORT, m_cbPort);
	//}}AFX_DATA_MAP
    }

BEGIN_MESSAGE_MAP(CRfidFlashDlg, CDialog)
	//{{AFX_MSG_MAP(CRfidFlashDlg)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_BN_CLICKED(IDC_READ, OnRead)
	ON_EN_CHANGE(IDC_NWRITE, OnChangeNwrite)
	ON_EN_CHANGE(IDC_INPUT, OnChangeInput)
	ON_BN_CLICKED(IDC_HEXMODE, OnHexmode)
	ON_BN_CLICKED(IDC_TEXTMODE, OnTextmode)
	ON_BN_CLICKED(IDC_WRITE, OnWrite)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRfidFlashDlg message handlers

BOOL CRfidFlashDlg::OnInitDialog()
    {
    struct sockaddr_in sa;
    int nDummy = TRUE;

	CDialog::OnInitDialog();

    // Request an icon for the dialog's title bar.
	SetIcon( m_hIcon, TRUE );
	
    // Set a fixed-width font for the data output box
    SendDlgItemMessage( IDC_HEXOUT, WM_SETFONT, (WPARAM)GetStockObject( ANSI_FIXED_FONT ), TRUE );

    // Some more initilizations
    m_cbPort.AddString( "2683" );
    SetDlgItemInt( IDC_NREAD,  0x70 );
    SetDlgItemInt( IDC_IREAD,  0 );
    m_fHexMode = FALSE;
    GetInput();
    memset( m_baInput, 0, sizeof( m_baInput ) );
    SetDlgItemInt( IDC_NWRITE, m_nInput );
    SetDlgItemInt( IDC_IWRITE, 0 );
    CheckRadioButton( IDC_TEXTMODE, IDC_HEXMODE, IDC_TEXTMODE );
    m_fRoboChange = FALSE;
    ConditionalFields();

    // Start an inventory broadcast that will find all W&T devices on the network.
    m_sockUdp = socket( AF_INET, SOCK_DGRAM, 0 );
    WSAAsyncSelect( m_sockUdp, m_hWnd, WM_APP, FD_READ );
    sa.sin_family = AF_INET;
    sa.sin_port = htons( 8513 );
    sa.sin_addr.s_addr = INADDR_BROADCAST;
    setsockopt( m_sockUdp, SOL_SOCKET, SO_BROADCAST, (char *)&nDummy, sizeof( nDummy ) );
    nDummy = sendto( m_sockUdp, "?", 1, 0, (struct sockaddr *)&sa, sizeof( sa ) ); 
	
	return TRUE;  // return TRUE, unless you set the focus to a control
    }


LRESULT CRfidFlashDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
    {
	if( message == WM_APP )
        {
        if( WSAGETSELECTEVENT( lParam ) == FD_READ && wParam == m_sockUdp )
            {
            // Found a W&T device, add it to the address combo box
            char caBuf[ 80 ];
            struct sockaddr_in sa;
            int nLen, nMax;

            nLen = sizeof( sa );
            nMax = sizeof( caBuf );
            nLen = recvfrom( m_sockUdp, caBuf, nMax, 0, (SOCKADDR *)&sa, &nLen );
            if( nLen >= 0 )
                m_cbAddress.AddString( inet_ntoa( sa.sin_addr ) );
            }
        if( WSAGETSELECTEVENT( lParam ) == FD_READ && wParam == m_sockTcp )
            {
            // Got an unsolicited packet from the device. Must be a filter match.
            T_FILTERMATCH fm;
            if( Collect( (char *)&fm, sizeof( fm ), 500 ) == CMD_FILTERMATCH )
                {
                CString str, str2;
                int i;
                for( i = 7; i >= 0; i-- )
                    {
                    str2.Format( "%02X", fm.baTagID[ i ] );
                    str += str2;
                    }
                i = m_lbTaglist.FindStringExact( -1, str );
                if( i >= 0 )
                    m_lbTaglist.DeleteString( i );
                if( fm.bAction != 0 )
                    m_lbTaglist.AddString( str );
                }
            }
        }
	
	return CDialog::WindowProc(message, wParam, lParam);
    }

void CRfidFlashDlg::OnConnect() 
    {
    struct sockaddr_in sa;
    WORD wPort;
    FD_SET fdsWrite, fdsError;
    timeval tv = { 0, 0 };
    CString str;
    CWaitCursor wc; // display an hourglass

    // Read target device information
    wPort = GetDlgItemInt( IDC_PORT );
    GetDlgItemText( IDC_ADDRESS, str );

    sa.sin_family = AF_INET;
    sa.sin_port = htons( wPort );
    sa.sin_addr.s_addr = inet_addr( str );
    m_sockTcp = socket( PF_INET, SOCK_STREAM, 0 );
    if( m_sockTcp == INVALID_SOCKET )
        return;
    
    // Request Winsock notifications for this socket (which implies
    // non-blocking mode btw., but we'd need that anyway).
    WSAAsyncSelect( m_sockTcp, m_hWnd, WM_APP, FD_READ );

    // Open the TCP connection (non-blocking connect)
    connect( m_sockTcp, (SOCKADDR*)&sa, sizeof( sa ) );
    FD_ZERO( &fdsWrite );  
    FD_SET( m_sockTcp, &fdsWrite );
    FD_ZERO( &fdsError );  
    FD_SET( m_sockTcp, &fdsError );
    // Allow up to four seconds to connect
    tv.tv_sec = 4;
    if( select( m_sockTcp+1, NULL, &fdsWrite, &fdsError, &tv ) <= 0 )
        {
        str.LoadString( IDS_E_TIMEOUT );
        goto socket_fail;
        }
    if( FD_ISSET( m_sockTcp, &fdsError ) )
        {
        str.Format( IDS_E_REFUSED, wPort );
        goto socket_fail;
        }

    m_nDrop = 0;
    SetDlgItemText( IDC_STATUS, "" );
    ConditionalFields();

    // Send password, if there is one, including the trailing null
    GetDlgItemText( IDC_PASSWD, str );
    if( !str.IsEmpty() )
        send( m_sockTcp, str, str.GetLength()+1, 0 );
    // Do a dummy transaction to find out if we were successful.
    Talk( CMD_GET_IO, NULL, 0 );
    Collect( NULL, 0, 2500 );
    return;

socket_fail:
    SetDlgItemText( IDC_STATUS, str );
    MessageBeep( MB_ICONERROR );
    closesocket( m_sockTcp );
    m_sockTcp = INVALID_SOCKET;
    }

void CRfidFlashDlg::OnDisconnect() 
    {
    closesocket( m_sockTcp );
    m_sockTcp = INVALID_SOCKET;
    SetDlgItemText( IDC_STATUS, "" );
    m_lbTaglist.ResetContent();
    ConditionalFields();
    }

void CRfidFlashDlg::OnChangeNwrite() 
    {
    if( m_fRoboChange )
        return;
    GetInput();
    m_nInput = GetDlgItemInt( IDC_NWRITE );
    if( m_nInput > sizeof( m_baInput ) )
        m_nInput = sizeof( m_baInput );
    ShowInput();
    }

void CRfidFlashDlg::OnChangeInput() 
    {
    if( m_fRoboChange )
        return;
    GetInput();
    m_fRoboChange = TRUE;
    SetDlgItemInt( IDC_NWRITE, m_nInput );
    m_fRoboChange = FALSE;
    // Expand the last valid character to fill the remainder of the input
    // buffer. 
    int i;
    if( m_nInput > 0 )
        for( i = m_nInput; i < sizeof( m_baInput ); i++ )
            m_baInput[ i ] = m_baInput[ m_nInput-1 ];
    }

void CRfidFlashDlg::OnHexmode() 
    {
    GetInput();
    m_fHexMode = TRUE;
    ShowInput();
    SetDlgItemInt( IDC_NWRITE, m_nInput );
    }

void CRfidFlashDlg::OnTextmode() 
    {
    GetInput();
    m_fHexMode = FALSE;
    ShowInput();
    SetDlgItemInt( IDC_NWRITE, m_nInput );
    }

void CRfidFlashDlg::OnWrite() 
    {
    T_FLASH_IO_PLUS fiop;
    BYTE baBuf[ 20 ];
    CString str;
    CWaitCursor wc; // show an hourglass until the function returns
    int i;

    SetDlgItemText( IDC_STATUS, "" );
    GetDlgItem( IDC_STATUS )->UpdateWindow();
    i = m_lbTaglist.GetCurSel();
    if( i < 0 )
        return;
    m_lbTaglist.GetText( i, str );
    for( i = 0; i < 8; i++ )
        fiop.baTagID[ 7-i ] = (BYTE)strtol( str.Mid( 2*i, 2 ), NULL, 16 );
    GetInput();
    fiop.wOffset = GetDlgItemInt( IDC_IWRITE );
    fiop.wLength = m_nInput;
    memcpy( fiop.baData, m_baInput, m_nInput );
    if( !Talk( CMD_WRITE_FLASH, (char *)&fiop, sizeof( T_FLASH_IO ) + fiop.wLength ) )
        return;
    for( ;; )
        {
        i = Collect( (char *)baBuf, sizeof( baBuf ), 3000 );
        if( i == CMD_WRITE_FLASH )
            break;  // we got the reply we expected
        if( i == 0 )
            return; // error (or no reply)
        }
    if( baBuf[ 8 ] != 0 )
        {
        // The device encountered an error while trying to write the flash.
        char *pcaError[] = { " (OK)", " (no answer)", " (write error)", " (busy)" };
        str.Format( IDS_E_FLASHIO, baBuf[ 8 ] );
        if( baBuf[ 8 ] < 4 )
            str += pcaError[ baBuf[ 8 ] ];
        }
    else
        str.LoadString( IDS_I_FLASH_WRITTEN );
    SetDlgItemText( IDC_STATUS, str );
    }

void CRfidFlashDlg::OnRead() 
    {
    T_FLASH_IO fio;
    BYTE baBuf[ 300 ];
    CString str;
    CWaitCursor wc; // show an hourglass until the function returns
    int i;

    SetDlgItemText( IDC_HEXOUT, "" );
    SetDlgItemText( IDC_STATUS, "" );
    GetDlgItem( IDC_HEXOUT )->UpdateWindow();
    GetDlgItem( IDC_STATUS )->UpdateWindow();
    i = m_lbTaglist.GetCurSel();
    if( i < 0 )
        return;
    m_lbTaglist.GetText( i, str );
    for( i = 0; i < 8; i++ )
        fio.baTagID[ 7-i ] = (BYTE)strtol( str.Mid( 2*i, 2 ), NULL, 16 );
    fio.wOffset = GetDlgItemInt( IDC_IREAD );
    fio.wLength = GetDlgItemInt( IDC_NREAD );
    if( !Talk( CMD_READ_FLASH, (char *)&fio, sizeof( fio ) ) )
        return;
    for( ;; )
        {
        i = Collect( (char *)baBuf, sizeof( baBuf ), 3000 );
        if( i == CMD_READ_FLASH )
            break;  // we got the reply we expected
        if( i == 0 )
            return; // error (or no reply)
        }
    if( baBuf[ 8 ] != 0 )
        {
        // The device encountered an error while trying to read the flash.
        char *pcaError[] = { " (OK)", " (no answer)", " (read error)", " (busy)" };
        str.Format( IDS_E_FLASHIO, baBuf[ 8 ] );
        if( baBuf[ 8 ] < 4 )
            str += pcaError[ baBuf[ 8 ] ];
        SetDlgItemText( IDC_STATUS, str );
        }
    else
        SetDlgItemText( IDC_HEXOUT, HexFormat( baBuf+9, fio.wLength, 12 ) );
    }

/////////////////////////////////////////////////////////////////////////////
// CRfidFlashDlg private subroutines

void CRfidFlashDlg::SafeEnableItem( int nCtrl, BOOL fEnable )
    {
    CWnd *pwnd, *pfoc;

    // Disabling a control that has the focus is ugly. So move the focus,
    // if required. Note that for comboboxes, the focus is usually on
    // a child window (edit control), not the control itself.
    pwnd = GetDlgItem( nCtrl );
    pfoc = GetFocus();
    if( !fEnable )
        if( pwnd == pfoc || (pfoc && pwnd == pfoc->GetParent() ) )
            SendMessage( WM_NEXTDLGCTL, 1, 0 );
    pwnd->EnableWindow( fEnable );
    }

void CRfidFlashDlg::ConditionalFields()
    {
    // Check for an established connection and enable/disable some controls 
    BOOL fOnline = (m_sockTcp != INVALID_SOCKET);

    SafeEnableItem( IDC_ADDRESS, !fOnline );
    SafeEnableItem( IDC_PORT,    !fOnline );
    SafeEnableItem( IDC_PASSWD,  !fOnline );
    SafeEnableItem( IDC_CONNECT, !fOnline );
    SafeEnableItem( IDC_DISCONNECT, fOnline );
    SafeEnableItem( IDC_TAGLIST,  fOnline );
    SafeEnableItem( IDC_READ,     fOnline );
    SafeEnableItem( IDC_NREAD,    fOnline );
    SafeEnableItem( IDC_IREAD,    fOnline );
    SafeEnableItem( IDC_TEXTMODE, fOnline );
    SafeEnableItem( IDC_HEXMODE,  fOnline );
    SafeEnableItem( IDC_INPUT,    fOnline );
    SafeEnableItem( IDC_WRITE,    fOnline );
    SafeEnableItem( IDC_NWRITE,   fOnline );
    SafeEnableItem( IDC_IWRITE,   fOnline );
    }


// Send a protocol packet

BOOL CRfidFlashDlg::Talk( int nCmd, const char *pcData, int nDataLen )
    {
    WT_BINHDR bhdr;
    CString str;

    // Create and send the header
    bhdr.zero = 0;
    bhdr.struct_type = nCmd;
    bhdr.struct_length = nDataLen + sizeof( bhdr );
    if( send( m_sockTcp, (char *)&bhdr, sizeof( bhdr ), 0 ) < 0 )
        goto socket_fail;

    // Send the related data, if there are any
    if( nDataLen > 0 )
        if( send( m_sockTcp, pcData, nDataLen, 0 ) < 0 )
            goto socket_fail;

    TRACE( "-> Type %04x, Size %d\n", bhdr.struct_type, bhdr.struct_length );
    return TRUE;

socket_fail:
    str.Format( IDS_E_CONNFAILED, WSAGetLastError() );
    OnDisconnect();
    SetDlgItemText( IDC_STATUS, str );
    return FALSE;
    }



// This is a blocking call which collects a protocol packet from the device.
// Return value is the command code of the reply, 0 if there was an error
// or no reply at all. 
// If you need to know the size of the packet, too, take a look at m_bhdrRcv.

int CRfidFlashDlg::Collect( char *pcBuf, int nBufSize, DWORD dwMaxWait )
    {
    int nResult, nDemand, nReceived;
    DWORD dwTick0;
    FD_SET fdsRead;
    char caLocalBuf[ 100 ];
    timeval tv = { 0, 100000 };  // 0.1 second wait
    CString str;

    // Collect the reply, but mind the timeout
    dwTick0 = GetTickCount();
    nReceived = 0;
    while( nReceived < sizeof( m_bhdrRcv ) )
        {
        if( GetTickCount() - dwTick0 > dwMaxWait )
            {
            if( nReceived == 0 )
                return 0;   // no reply at all is OK
            str.LoadString( IDS_E_NOREPLY );
            goto fail;      // an incomplete header is not
            }
        FD_ZERO( &fdsRead );
        FD_SET( m_sockTcp, &fdsRead );
        if( select( m_sockTcp+1, &fdsRead, NULL, NULL, &tv ) > 0 )
            {
            if( m_nDrop > 0 )
                {
                // Throw away any remains of a previous packet
                nDemand = sizeof( caLocalBuf );
                if( nDemand > m_nDrop )
                    nDemand = m_nDrop;
                nResult = recv( m_sockTcp, caLocalBuf, nDemand, 0 );
                if( nResult > 0 )
                    m_nDrop -= nResult;
                else
                    goto socket_fail;
                }
            else
                {
                // Header data
                nResult = recv( m_sockTcp, ((char *)&m_bhdrRcv) + nReceived, sizeof( m_bhdrRcv ) - nReceived, 0 );
                if( nResult > 0 )
                    nReceived += nResult;
                else
                    goto socket_fail;
                }
            }
        }
    if( strcmp( (char *)&m_bhdrRcv, "PASSWD?" ) == 0 )
        {
        str = "PASSWD?";
        goto fail;
        }

    // In case of an error, switch to our local buffer. The caller may have
    // supplied a buffer of less than two bytes, and now he won't be getting 
    // the data that he wanted, anyway.
    switch( m_bhdrRcv.struct_type )
        {
        case ERR_SYNTAX:
        case ERR_SEMANTIC:
            pcBuf = caLocalBuf;
            nBufSize = sizeof( caLocalBuf );
            break;
        }

    // Collect the data announced by the header, or at least as many as the
    // supplied buffer will hold.
    nDemand = m_bhdrRcv.struct_length - sizeof( m_bhdrRcv );
    if( nDemand > nBufSize )
        {
        m_nDrop = nDemand - nBufSize;
        nDemand = nBufSize;
        }
    nReceived = 0;
    while( nReceived < nDemand )
        {
        if( GetTickCount() - dwTick0 > dwMaxWait )
            {
            // The device did not supply all of its data on time. This is 
            // however not a deadly error, i.e. we can recover from it 
            // without resetting the connection.
            m_nDrop += nDemand;
            return 0;
            }
        FD_ZERO( &fdsRead );
        FD_SET( m_sockTcp, &fdsRead );
        if( select( m_sockTcp+1, &fdsRead, NULL, NULL, &tv ) > 0 )
            {
            nResult = recv( m_sockTcp, pcBuf + nReceived, nDemand - nReceived, 0 );
            if( nResult > 0 )
                nReceived += nResult;
            else
                goto socket_fail;
            }
        }

    // Check for error responses
    switch( m_bhdrRcv.struct_type )
        {
        case ERR_SYNTAX:
            // Apparently we screwed up with the network protocol. It's
            // better to abandon the connection.
            str.Format( IDS_E_SYNTAX, *(WORD *)caLocalBuf );
            goto fail;
        case ERR_SEMANTIC:
            str.Format( IDS_E_SEMANTIC, *(WORD *)caLocalBuf );
            SetDlgItemText( IDC_STATUS, str );
            return 0;
        }

    TRACE( "<- Type %04x, Size %d\n", m_bhdrRcv.struct_type, m_bhdrRcv.struct_length );
    return m_bhdrRcv.struct_type;

socket_fail:
    str.Format( IDS_E_CONNFAILED, WSAGetLastError() );
fail:
    OnDisconnect();
    SetDlgItemText( IDC_STATUS, str );
    return 0;
    }


CString CRfidFlashDlg::HexFormat( BYTE *baData, int nSize, int nWidth )
    {
    // Format binary data for text output.
    CString str, str2;
    char caBuf[ 20 ];
    int i, j, nPart;

    for( i = 0; i < nSize; i++ )
        {
        // hex digits
        str2.Format( "%02X ", baData[ i ] );
        if( (i & 3) == 3 )
            str2 += " ";
        str += str2;
        if( (i % nWidth) == nWidth-1 )
            {
            // append ASCII dump
            str += "  ";
            for( j = 0; j < nWidth; j++ )
                {
                caBuf[ j ] = baData[ i - (nWidth-1) + j ];
                if( (caBuf[ j ] & 0x7f) < ' ' )
                     caBuf[ j ] = '';
                }
            caBuf[ j ] = '\0';
            str += caBuf;
            str += "\r\n";
            }
        }
    // Special treatment for the last line, in case it holds less than
    // nWidth bytes.
    nPart = i % nWidth;
    if( nPart != 0 )
        {
        for( j = nPart; j < nWidth; j++ )
            {
            str += "   ";
            if( (j & 3) == 3 )
                str += " ";
            }
        str += "  ";
        for( j = 0; j < nPart; j++ )
            {
            caBuf[ j ] = baData[ i - nPart + j ];
            if( (caBuf[ j ] & 0x7f) < ' ' )
                 caBuf[ j ] = '';
            }
        caBuf[ j ] = '\0';
        str += caBuf;
        str += "\r\n";
        }
    str.TrimRight();
    return str;
    }

// Read/Write binary data from the input field.

void CRfidFlashDlg::GetInput()
    {
    CString str;
    int i;

    GetDlgItemText( IDC_INPUT, str );
    if( m_fHexMode )
        {
        str.Replace( " ", "" );
        m_nInput = 0;
        while( !str.IsEmpty() )
            {
            m_baInput[ m_nInput++ ] = (BYTE)strtol( str.Left( 2 ), NULL, 16 );
            str.Delete( 0 );
            str.Delete( 0 );
            if( m_nInput == sizeof( m_baInput ) )
                break;
            }
        }
    else
        {
        m_nInput = str.GetLength();
        if( m_nInput > sizeof( m_baInput ) )
            m_nInput = sizeof( m_baInput );
        for( i = 0; i < m_nInput; i++ )
            m_baInput[ i ] = str.GetAt( i );
        //m_baInput[ m_nInput++ ] = 0;
        }
    }

void CRfidFlashDlg::ShowInput()
    {
    CString str, str2;
    int i;

    if( m_fHexMode )
        for( i = 0; i < m_nInput; i++ )
            {
            str2.Format( "%02X ", m_baInput[ i ] );
            str += str2;
            }
    else
        for( i = 0; i < m_nInput; i++ )
            {
            if( m_baInput[ i ] == 0 )
                break;
            str += (char)m_baInput[ i ];
            }
    m_fRoboChange = TRUE;
    SetDlgItemText( IDC_INPUT, str );
    m_fRoboChange = FALSE;
    }
