// RfidIODlg.cpp : Implementation
//

#include "stdafx.h"
#include "RfidIO.h"
#include "RfidIODlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRfidIODlg dialog box

CRfidIODlg::CRfidIODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRfidIODlg::IDD, pParent)
    {
	//{{AFX_DATA_INIT(CRfidIODlg)
		// Class Wizard will add member initializations here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon( IDR_MAINFRAME );
    m_sockUdp = INVALID_SOCKET;
    m_sockTcp = INVALID_SOCKET;
    }

CRfidIODlg::~CRfidIODlg()
    {
    if( m_sockUdp != INVALID_SOCKET )
        closesocket( m_sockUdp );
    if( m_sockTcp != INVALID_SOCKET )
        closesocket( m_sockTcp );
    }

void CRfidIODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRfidIODlg)
	DDX_Control(pDX, IDC_PORT, m_cbPort);
	DDX_Control(pDX, IDC_ADDRESS, m_cbAddress);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRfidIODlg, CDialog)
	//{{AFX_MSG_MAP(CRfidIODlg)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRfidIODlg message handlers

BOOL CRfidIODlg::OnInitDialog()
    {
    struct sockaddr_in sa;
    int nDummy = TRUE;

	CDialog::OnInitDialog();

    // Request an icon for the dialog's title bar.
	SetIcon( m_hIcon, TRUE );
	
	// Put default values into the combo boxes
    m_cbPort.AddString( "2683" );
    // Start an inventory broadcast that will find all W&T devices on the network.
    m_sockUdp = socket( AF_INET, SOCK_DGRAM, 0 );
    WSAAsyncSelect( m_sockUdp, m_hWnd, WM_APP, FD_READ );
    sa.sin_family = AF_INET;
    sa.sin_port = htons( 8513 );
    sa.sin_addr.s_addr = INADDR_BROADCAST;
    setsockopt( m_sockUdp, SOL_SOCKET, SO_BROADCAST, (char *)&nDummy, sizeof( nDummy ) );
    nDummy = sendto( m_sockUdp, "?", 1, 0, (struct sockaddr *)&sa, sizeof( sa ) ); 
    ConditionalFields();
	
	return TRUE;  // return TRUE, unless you set the focus to a control
    }


LRESULT CRfidIODlg::WindowProc( UINT message, WPARAM wParam, LPARAM lParam ) 
    {
	if( message == WM_APP )
        {
        if( WSAGETSELECTEVENT( lParam ) == FD_READ && wParam == m_sockUdp )
            {
            // Found a W&T device, add it to the address combo box
            char caBuf[ 80 ];
            struct sockaddr_in sa;
            int nLen, nMax;

            nLen = sizeof( sa );
            nMax = sizeof( caBuf );
            nLen = recvfrom( m_sockUdp, caBuf, nMax, 0, (SOCKADDR *)&sa, &nLen );
            if( nLen >= 0 )
                m_cbAddress.AddString( inet_ntoa( sa.sin_addr ) );
            }
        }
	
	return CDialog::WindowProc(message, wParam, lParam);
    }


void CRfidIODlg::OnConnect() 
    {
    struct sockaddr_in sa;
    WORD wPort;
    FD_SET fdsWrite, fdsError;
    u_long lDummy;
    timeval tv = { 0, 0 };
    CString str;
    CWaitCursor wc; // display an hourglass

    // Read target device information
    wPort = GetDlgItemInt( IDC_PORT );
    GetDlgItemText( IDC_ADDRESS, str );

    sa.sin_family = AF_INET;
    sa.sin_port = htons( wPort );
    sa.sin_addr.s_addr = inet_addr( str );
    m_sockTcp = socket( PF_INET, SOCK_STREAM, 0 );
    if( m_sockTcp == INVALID_SOCKET )
        return;
    
    // Open the TCP connection (non-blocking connect)
    lDummy = 1;
    ioctlsocket( m_sockTcp, FIONBIO, &lDummy );
    connect( m_sockTcp, (SOCKADDR*)&sa, sizeof( sa ) );
    FD_ZERO( &fdsWrite );  
    FD_SET( m_sockTcp, &fdsWrite );
    FD_ZERO( &fdsError );  
    FD_SET( m_sockTcp, &fdsError );
    // Allow up to four seconds to connect
    tv.tv_sec = 4;
    if( select( m_sockTcp+1, NULL, &fdsWrite, &fdsError, &tv ) <= 0 )
        {
        str.LoadString( IDS_E_TIMEOUT );
        goto socket_fail;
        }
    if( FD_ISSET( m_sockTcp, &fdsError ) )
        {
        str.Format( IDS_E_REFUSED, wPort );
        goto socket_fail;
        }
    // Return to blocking mode
    lDummy = 0;
    ioctlsocket( m_sockTcp, FIONBIO, &lDummy );

    m_nDrop = 0;
    SetDlgItemText( IDC_STATUS, "" );
    ConditionalFields();
    // Start the polling for I/O status, 1000ms interval
    SetTimer( 1234, 1000, NULL );

    // Send password, if there is one, including the trailing null
    GetDlgItemText( IDC_PASSWD, str );
    if( !str.IsEmpty() )
        send( m_sockTcp, str, str.GetLength()+1, 0 );
    // Do a dummy transaction to find out if we were successful.
    Talk( CMD_GET_IO, NULL, 0 );
    Collect( NULL, 0, 2500 );
    return;

socket_fail:
    SetDlgItemText( IDC_STATUS, str );
    MessageBeep( MB_ICONERROR );
    closesocket( m_sockTcp );
    m_sockTcp = INVALID_SOCKET;
    }

void CRfidIODlg::OnDisconnect() 
    {
    KillTimer( 1234 );
    closesocket( m_sockTcp );
    m_sockTcp = INVALID_SOCKET;
    SetDlgItemText( IDC_STATUS, "" );
    ConditionalFields();
    }

void CRfidIODlg::OnTimer( UINT nIDEvent )
    {
    BYTE baIoMap[ 2 ];
    int nResult;

    Talk( CMD_GET_IO, NULL, 0 );
    for( ;; )
        {
        nResult = Collect( (char *)baIoMap, 2, 2500 );
        // Abort after an error, otherwise continue until we've got
        // the reply that we expected.
        if( nResult == CMD_GET_IO )
            {
            CheckDlgButton( IDC_OUTP1, baIoMap[ 0 ] & 0x01 );
            CheckDlgButton( IDC_OUTP2, baIoMap[ 0 ] & 0x02 );
            CheckDlgButton( IDC_OUTP3, baIoMap[ 0 ] & 0x04 );
            CheckDlgButton( IDC_OUTP4, baIoMap[ 0 ] & 0x08 );
            CheckDlgButton( IDC_RELAIS,baIoMap[ 0 ] & 0x10 );
            CheckDlgButton( IDC_LED1,  baIoMap[ 0 ] & 0x40 );
            CheckDlgButton( IDC_LED2,  baIoMap[ 0 ] & 0x80 );

            CheckDlgButton( IDC_INP1,  baIoMap[ 1 ] & 0x01 );
            CheckDlgButton( IDC_INP2,  baIoMap[ 1 ] & 0x02 );
            CheckDlgButton( IDC_INP3,  baIoMap[ 1 ] & 0x04 );
            CheckDlgButton( IDC_INP4,  baIoMap[ 1 ] & 0x08 );
            break;
            }
        if( nResult == 0 )
            break;
        }
    }

BOOL CRfidIODlg::OnCommand(WPARAM wParam, LPARAM lParam) 
    {
    int nCtrl;
    BYTE bValue, bMask, ba[ 2 ];
    
    nCtrl = LOWORD( wParam );
    bMask = 0;
    switch( nCtrl )
        {
        case IDC_OUTP1:
            bMask = 0x01;
            break;
        case IDC_OUTP2:
            bMask = 0x02;
            break;
        case IDC_OUTP3:
            bMask = 0x04;
            break;
        case IDC_OUTP4:
            bMask = 0x08;
            break;
        case IDC_RELAIS:
            bMask = 0x10;
            break;
        case IDC_LED1:
            bMask = 0x40;
            break;
        case IDC_LED2:
            bMask = 0x80;
            break;
        }
    if( bMask != 0 )
        {
        bValue = IsDlgButtonChecked( nCtrl ) ? bMask : 0;
        ba[ 0 ] = bValue;
        ba[ 1 ] = bMask;
        Talk( CMD_SET_OUTPUT, (char *)ba, 2 );
        // We don't care about the reply, but since it is the same type
        // as for CMD_GETIO, we have to collect it now, to avoid confusion.
        // (Otherwise these packets would queue up endlessly.)
        Collect( NULL, 0, 2500 );
        }

    return CDialog::OnCommand(wParam, lParam);
    }

/////////////////////////////////////////////////////////////////////////////
// CRfidIODlg private subroutines

void CRfidIODlg::SafeEnableItem( int nCtrl, BOOL fEnable )
    {
    CWnd *pwnd, *pfoc;

    // Disabling a control that has the focus is ugly. So move the focus,
    // if required. Note that for comboboxes, the focus is usually on
    // a child window (edit control), not the control itself.
    pwnd = GetDlgItem( nCtrl );
    pfoc = GetFocus();
    if( !fEnable )
        if( pwnd == pfoc || (pfoc && pwnd == pfoc->GetParent() ) )
            SendMessage( WM_NEXTDLGCTL, 1, 0 );
    pwnd->EnableWindow( fEnable );
    }

void CRfidIODlg::ConditionalFields()
    {
    // Check for an established connection and enable/disable some controls 
    BOOL fOnline = (m_sockTcp != INVALID_SOCKET);

    SafeEnableItem( IDC_ADDRESS, !fOnline );
    SafeEnableItem( IDC_PORT,    !fOnline );
    SafeEnableItem( IDC_PASSWD,  !fOnline );
    SafeEnableItem( IDC_CONNECT, !fOnline );
    SafeEnableItem( IDC_DISCONNECT, fOnline );
    SafeEnableItem( IDC_LED1,   fOnline );
    SafeEnableItem( IDC_LED2,   fOnline );
    SafeEnableItem( IDC_RELAIS, fOnline );
    SafeEnableItem( IDC_OUTP1,  fOnline );
    SafeEnableItem( IDC_OUTP2,  fOnline );
    SafeEnableItem( IDC_OUTP3,  fOnline );
    SafeEnableItem( IDC_OUTP4,  fOnline );
    }


// Send a protocol packet

BOOL CRfidIODlg::Talk( int nCmd, const char *pcData, int nDataLen )
    {
    WT_BINHDR bhdr;
    CString str;

    // Create and send the header
    bhdr.zero = 0;
    bhdr.struct_type = nCmd;
    bhdr.struct_length = nDataLen + sizeof( bhdr );
    if( send( m_sockTcp, (char *)&bhdr, sizeof( bhdr ), 0 ) < 0 )
        goto socket_fail;

    // Send the related data, if there are any
    if( nDataLen > 0 )
        if( send( m_sockTcp, pcData, nDataLen, 0 ) < 0 )
            goto socket_fail;

    TRACE( "-> Type %04x, Size %d\n", bhdr.struct_type, bhdr.struct_length );
    return TRUE;

socket_fail:
    str.Format( IDS_E_CONNFAILED, WSAGetLastError() );
    OnDisconnect();
    SetDlgItemText( IDC_STATUS, str );
    return FALSE;
    }



// This is a blocking call which collects a protocol packet from the device.
// Return value is the command code of the reply, 0 if there was an error
// or no reply at all. 
// If you need to know the size of the packet, too, take a look at m_bhdrRcv.

int CRfidIODlg::Collect( char *pcBuf, int nBufSize, DWORD dwMaxWait )
    {
    int nResult, nDemand, nReceived;
    DWORD dwTick0;
    FD_SET fdsRead;
    char caLocalBuf[ 100 ];
    timeval tv = { 0, 100000 };  // 0.1 second wait
    CString str;

    // Collect the reply, but mind the timeout
    dwTick0 = GetTickCount();
    nReceived = 0;
    while( nReceived < sizeof( m_bhdrRcv ) )
        {
        if( GetTickCount() - dwTick0 > dwMaxWait )
            {
            if( nReceived == 0 )
                return 0;   // no reply at all is OK
            str.LoadString( IDS_E_NOREPLY );
            goto fail;      // an incomplete header is not
            }
        FD_ZERO( &fdsRead );
        FD_SET( m_sockTcp, &fdsRead );
        if( select( m_sockTcp+1, &fdsRead, NULL, NULL, &tv ) > 0 )
            {
            if( m_nDrop > 0 )
                {
                // Throw away any remains of a previous packet
                nDemand = sizeof( caLocalBuf );
                if( nDemand > m_nDrop )
                    nDemand = m_nDrop;
                nResult = recv( m_sockTcp, caLocalBuf, nDemand, 0 );
                if( nResult > 0 )
                    m_nDrop -= nResult;
                else
                    goto socket_fail;
                }
            else
                {
                // Header data
                nResult = recv( m_sockTcp, ((char *)&m_bhdrRcv) + nReceived, sizeof( m_bhdrRcv ) - nReceived, 0 );
                if( nResult > 0 )
                    nReceived += nResult;
                else
                    goto socket_fail;
                }
            }
        }
    if( strcmp( (char *)&m_bhdrRcv, "PASSWD?" ) == 0 )
        {
        str = "PASSWD?";
        goto fail;
        }

    // In case of an error, switch to our local buffer. The caller may have
    // supplied a buffer of less than two bytes, and now he won't be getting 
    // the data that he wanted, anyway.
    switch( m_bhdrRcv.struct_type )
        {
        case ERR_SYNTAX:
        case ERR_SEMANTIC:
            pcBuf = caLocalBuf;
            nBufSize = sizeof( caLocalBuf );
            break;
        }

    // Collect the data announced by the header, or at least as many as the
    // supplied buffer will hold.
    nDemand = m_bhdrRcv.struct_length - sizeof( m_bhdrRcv );
    if( nDemand > nBufSize )
        {
        m_nDrop = nDemand - nBufSize;
        nDemand = nBufSize;
        }
    nReceived = 0;
    while( nReceived < nDemand )
        {
        if( GetTickCount() - dwTick0 > dwMaxWait )
            {
            // The device did not supply all of its data on time. This is 
            // however not a deadly error, i.e. we can recover from it 
            // without resetting the connection.
            m_nDrop += nDemand;
            return 0;
            }
        FD_ZERO( &fdsRead );
        FD_SET( m_sockTcp, &fdsRead );
        if( select( m_sockTcp+1, &fdsRead, NULL, NULL, &tv ) > 0 )
            {
            nResult = recv( m_sockTcp, pcBuf + nReceived, nDemand - nReceived, 0 );
            if( nResult > 0 )
                nReceived += nResult;
            else
                goto socket_fail;
            }
        }

    // Check for error responses
    switch( m_bhdrRcv.struct_type )
        {
        case ERR_SYNTAX:
            // Apparently we screwed up with the network protocol. It's
            // better to abandon the connection.
            str.Format( IDS_E_SYNTAX, *(WORD *)caLocalBuf );
            goto fail;
        case ERR_SEMANTIC:
            str.Format( IDS_E_SEMANTIC, *(WORD *)caLocalBuf );
            SetDlgItemText( IDC_STATUS, str );
            return 0;
        }

    TRACE( "<- Type %04x, Size %d\n", m_bhdrRcv.struct_type, m_bhdrRcv.struct_length );
    return m_bhdrRcv.struct_type;

socket_fail:
    str.Format( IDS_E_CONNFAILED, WSAGetLastError() );
fail:
    OnDisconnect();
    SetDlgItemText( IDC_STATUS, str );
    return 0;
    }
